\documentclass[a4paper,UTF8]{ctexart}
\usepackage{listings}
\usepackage{amsmath}
\newfontfamily\codefont{DejaVu Sans Mono}
\setmonofont{DejaVu Sans Mono}
\lstset{basicstyle=\small\codefont,frame=single,numbers=left}
\setCJKmainfont[Mapping = fullwidth-stop, % 中文空心句号映射为实心句点
  BoldFont=FZHei-B01,ItalicFont=FZKai-Z03,
  BoldItalicFont=FZFangSong-Z02]{FZNewShuSong-Z10}

\begin{document}
\subsection*{2021“津门杯”网络安全创新大赛，crypto，rsa}

题目是以下 rsa.txt 文件。

\begin{lstlisting}
小李截获一个RSA加密信息，能帮忙解开吗？

c=587037942022177089472842410257313474001...418  # 308 digits

e=119393861845960762048898683511487799317...6727 # 309 digits

n=143197135363873763765271313889482832065...7427 # 309 digits
\end{lstlisting}

\subsection*{解答}

运行下面的 create\_pub.py 程序创建公钥。

\lstinputlisting[language=python]{create_pub.py}

\begin{lstlisting}[numbers=none]
$ python create_pub.py > /tmp/pub
\end{lstlisting}

我们要想办法将
309~位的合数$n$分解为素数$p$和$q$的乘积。
通过运行以下命令来完成这一步。
运行 1~分钟后（使用 wiener 方法）得到私钥。

\begin{lstlisting}[numbers=none]
$ RsaCtfTool.py --private --publickey /tmp/pub --output /tmp/pem
[*] Testing key flag.pub.
attack initialized...
attack initialized...
[*] Performing lucas_gcd attack on flag.pub.
100%|...| 9999/9999 [00:00<00:00, 125045.38it/s]
[+] Time elapsed: 0.0840 sec.
[*] Performing nonRSA attack on flag.pub.
[+] Time elapsed: 0.0011 sec.
[*] Performing fibonacci_gcd attack on flag.pub.
100%|...| 9999/9999 [00:00<00:00, 123242.98it/s]
[+] Time elapsed: 0.0815 sec.
[*] Performing system_primes_gcd attack on flag.pub.
100%|...| 7007/7007 [00:00<00:00, 945699.01it/s]
[+] Time elapsed: 0.0270 sec.
[*] Performing pastctfprimes attack on flag.pub.
100%|...| 113/113 [00:00<00:00, 879325.33it/s]
[+] Time elapsed: 0.0005 sec.
[*] Performing smallq attack on flag.pub.
[+] Time elapsed: 0.2497 sec.
[*] Performing mersenne_primes attack on flag.pub.
 27%|...| 14/51 [00:00<00:00, 371647.19it/s]
[+] Time elapsed: 0.0005 sec.
[*] Performing hart attack on flag.pub.
[!] Timeout.
[+] Time elapsed: 60.0003 sec.
[*] Performing primorial_pm1_gcd attack on flag.pub.
100%|...| 10000/10000 [00:00<00:00, 17896.31it/s]
[+] Time elapsed: 0.5592 sec.
[*] Performing wiener attack on flag.pub.
 20%|...| 106/525 [00:00<00:00, 564925.32it/s]
[*] Attack success with wiener method !
[+] Total time elapsed min,max,avg: 0.0005/60.0003/6.7782 sec.
Results for flag.pub:
...
\end{lstlisting}

运行下面的 solve\_rsa.py 程序得到答案。

\lstinputlisting[language=python]{solve_rsa.py}

\begin{lstlisting}[numbers=none]
$ python solve_rsa.py
b'flag{ZTAtG3hjH2zpcoB5}'
\end{lstlisting}

\end{document}
